# The $name parameter is the file location where the contents will be saved.
class krb5conf (
  Hash $libdefaults,
  Hash $realms,
  Hash $domain_realm,
  Hash $logging,
  Optional[String] $appdefaults_source = undef,
  Optional[Hash]   $other_sections     = {},
) {

  $libdefaults_string  = krb5conf::simple_hash_section($libdefaults, 'libdefaults')
  $realms_string       = krb5conf::realms($realms)
  $domain_realm_string = krb5conf::simple_hash_section($domain_realm, 'domain_realm')
  $logging_string      = krb5conf::simple_hash_section($logging, 'logging')

  if ($appdefaults_source) {
    $appdefaults_string = file($appdefaults_source)
  } else {
    $appdefaults_string = ""
  }

  $other_section_strings =
    $other_sections.map |$section_name, $section_hash| { krb5conf::simple_hash_section($section_hash, $section_name) }

  # Put them all together.
  $all_sections = $other_section_strings +
  [
    $appdefaults_string,
    $libdefaults_string,
    $realms_string,
    $domain_realm_string,
    $logging_string,
  ]

  $complete_string = $all_sections.reduce |$memo, $value| { "${memo}\n${value}" }

  file { $name:
    content => $complete_string
  }
}
